import { DequeTy } from '../types';
export declare class Deque<T> implements DequeTy<T> {
    private items;
    constructor();
    /**
     * Adds an element to the front of the deque
     */
    pushFront(element: T): void;
    /**
     * Adds an element to the back of the deque
     */
    pushBack(element: T): void;
    /**
     * Removes and returns the front element from the deque, or undefined if deque is empty
     */
    popFront(): T | undefined;
    /**
     * Removes and returns the back element from the deque, or undefined if deque is empty
     */
    popBack(): T | undefined;
    /**
     * Returns the front element without removing it, or undefined if deque is empty
     */
    front(): T | undefined;
    /**
     * Returns the back element without removing it, or undefined if deque is empty
     */
    back(): T | undefined;
    /**
     * Returns true if the deque is empty, false otherwise
     */
    empty(): boolean;
    /**
     * Returns the number of elements in the deque
     */
    size(): number;
    /**
     * Removes all elements from the deque
     */
    clear(): void;
}
