import { LinkedListTy } from '../types';
export declare class LinkedList<T> implements LinkedListTy<T> {
    private head;
    private tail;
    private length;
    constructor();
    /**
     * Adds an element to the end of the list
     */
    pushBack(element: T): void;
    /**
     * Adds an element to the front of the list
     */
    pushFront(element: T): void;
    /**
     * Inserts an element at the specified position. Returns true if successful, false if position is invalid
     */
    insert(element: T, position: number): boolean;
    /**
     * Removes the first element that satisfies the predicate. Returns true if an element was removed, false otherwise.
     */
    removeIf(condition: (element: T) => boolean): boolean;
    /**
     * Removes and returns the element at the specified position. Returns undefined if position is invalid
     */
    removeAt(position: number): T | undefined;
    /**
     * Returns the element at the specified position without removing it. Returns undefined if position is invalid
     */
    get(position: number): T | undefined;
    /**
     * Returns true if the list is empty, false otherwise
     */
    empty(): boolean;
    /**
     * Returns the number of elements in the list
     */
    size(): number;
    /**
     * Removes all elements from the list
     */
    clear(): void;
}
