import { PriorityQueueTy } from '../types';
export declare class PriorityQueue<T> implements PriorityQueueTy<T> {
    private items;
    constructor();
    /**
     * Adds an element with a priority to the queue.
     * Lower priority numbers have higher precedence.
     */
    push(element: T, priority: number): void;
    /**
     * Removes and returns the highest priority element from the queue,
     * or undefined if queue is empty.
     */
    pop(): T | undefined;
    /**
     * Returns the highest priority element without removing it,
     * or undefined if queue is empty.
     */
    front(): T | undefined;
    /**
     * Checks if the queue is empty. Returns true if empty, false otherwise.
     */
    empty(): boolean;
    /**
     * Returns the number of elements in the queue.
     */
    size(): number;
    /**
     * Removes all elements from the queue.
     */
    clear(): void;
}
