import { StackTy } from '../types/';
export declare class Stack<T> implements StackTy<T> {
    private items;
    constructor();
    /**
     * Adds an element to the top of the stack.
     */
    push(element: T): void;
    /**
     * Removes and returns the top element from the stack, or undefined if stack is empty.
     */
    pop(): T | undefined;
    /**
     * Returns the top element of the stack without removing it, or undefined if stack is empty.
     */
    top(): T | undefined;
    /**
     * Checks if the stack is empty. Returns true if the stack is empty, false otherwise.
     */
    empty(): boolean;
    /**
     * Returns the number of elements in the stack. The size of the stack
     */
    size(): number;
    /**
     * Removes all elements from the stack.
     */
    clear(): void;
}
